/* ---------------------------------------------------------------------------
**	ICS 534x PLL and ramdac driver
** ---------------------------------------------------------------------------
**
**	Copyright (C) 1997 by Andreas Vogler
**	Additions for PLL driver by Emmanuel marty
**
**	This program is free software; you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation; either version 2, or (at your option)
**	any later version.
**
**	You should have received a copy of the GNU General Public License
**	along with this program; see the file COPYING.  If not, write to
**	the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
**
** ---------------------------------------------------------------------------
**	This code is derived from the following source of information
**	[1]	ICS 5342 data sheet
**
**	MAINTAINER	Andreas_Vogler
**
**	$Log: 5342.h,v $
**	Revision 1.2  1997/12/16 13:31:56  emarty
**	added pll register definitions
**	
**	Revision 1.1  1997/08/03 20:11:20  seeger
**	ICS 5342 DAC header by Andreas Vogler, initial checkin.
**	
*/

#ifndef _ICS_5342_H
#define _ICS_5342_H

/* 8bit pixelbus */
#define DAC_MODE_0 0x00		/* 8bit Pseudo Color */
#define DAC_MODE_1 0x20		/* 15 bit Hi Color */
#define DAC_MODE_2 0x60		/* 16 bit Hi Color (XGA)*/
#define DAC_MODE_3 0x80		/* 24 bit True Color */

/* 16 bit pixelbus */
#define DAC_MODE_4 0x10		/* 8 bit Pseudo Color */
#define DAC_MODE_5 0x30		/* 15 bit Hi Color */
#define DAC_MODE_6 0x50		/* 16 bit Hi Color */
#define DAC_MODE_7 0x70		/* 24 bit True Color (word aligned) */
#define DAC_MODE_8 0x90		/* 24 bit True Color (packed) */

#define DAC_PLLWRITE 0x04	/* pll write index register */
#define DAC_PLLDATA  0x05	/* pll data register */
#define DAC_COMMAND  0x06	/* command register */
#define DAC_PLLREAD  0x07	/* pll read index register */

/*	ICS 5342 PLL registers	*/

#define PLL_CLK0_F0	0x00
#define PLL_CLK0_F1	0x01
#define PLL_CLK0_F2	0x02
#define PLL_CLK0_F3	0x03
#define PLL_CLK0_F4	0x04
#define PLL_CLK0_F5	0x05
#define PLL_CLK0_F6	0x06
#define PLL_CLK0_F7	0x07
#define PLL_CLK1_FA	0x09
#define PLL_CLK1_FB	0x0A
#define PLL_CONTROL	0x0E

#endif /* _ICS_5342_H */ 
