/*
** Common registers for the Millenium/Mystique
*/
#ifndef _MGA_COMMON_MMIO_H_
#define _MGA_COMMON_MMIO_H_

#define NoSEQRegs	0x05
#define	NoCRTRegs	0x19
#define NoGRCRegs	0x09
#define NoATCRegs	0x15
#define NoExtVgaRegs	0x06

struct statetable
{
	uint8 MISC;
	uint8 SEQ[NoSEQRegs];
	uint8 CRT[NoCRTRegs];
	uint8 GRC[NoGRCRegs];
	uint8 ATC[NoATCRegs];
	uint8 ExtVga[NoExtVgaRegs];
};

void ECRT_out8(struct kgi_display *dpy, uint8 val, uint8 reg);
uint8 ECRT_in8(struct kgi_display *dpy, uint8 reg);
void MISC_out8(struct kgi_display *dpy, uint8 val);
uint8 MISC_in8(struct kgi_display *dpy);
void CRT_out8(struct kgi_display *dpy, uint8 val, uint8 reg);
uint8 CRT_in8(struct kgi_display *dpy, uint8 reg);
void GRC_out8(struct kgi_display *dpy, uint8 val, uint8 reg);
uint8 GRC_in8(struct kgi_display *dpy, uint8 reg);
void SEQ_out8(struct kgi_display *dpy, uint8 val, uint8 reg);
uint8 SEQ_in8(struct kgi_display *dpy, uint8 reg);
void ATC_out8(struct kgi_display *dpy, uint8 val, uint8 reg);
/* ATC_in8 not implemented coz not used */

void restore_ExtVga(struct kgi_display *dpy, uint8 *buf);
void restore_SEQ(struct kgi_display *dpy, uint8 *buf);
void restore_CRT(struct kgi_display *dpy, uint8 *buf);
void restore_GRC(struct kgi_display *dpy, uint8 *buf);
void restore_ATC(struct kgi_display *dpy, uint8 *buf);

#endif /* _MGA_COMMON_MMIO_H_ */
