/*\
|*| ---------------------------------------------------------------------------
|*|	Paradise PVGA1B register definitions (for "wd90c00" and "wd90c90")
|*| ---------------------------------------------------------------------------
|*|
|*|	Copyright (C) 1997 by Brian S. Julin, <bri@calyx.com>
|*|
|*|	This header is free software; you can redistribute it and/or modify
|*|	it under the terms of the GNU Library General Public License as 
|*|	published by the Free Software Foundation; either version 2, or 
|*|     (at your option) any later version.
|*|
|*|	You should have received a copy of the GNU Library General Public 
|*|     License along with this program; see the file COPYING.LGPL.  
|*|	If not, write to the Free Software Foundation, 675 Mass Ave, 
|*|     Cambridge, MA 02139, USA.
|*| ---------------------------------------------------------------------------
\*/

/* MAINTAINER	Brian S. Julin, <bri@calyx.com> */

#ifndef _wd90c00_h
#define _wd90c00_h

#include "WD/pvga1a.h"

/* CRT -- New registers */

          #define CRT_UPCRT_LOCK 0x29
                  #define CR29_WLOCK_MASK 0x07
                  #define CR29_WUNLOCK    0x05
                  #define CR29_WLOCK      0x00
                  #define CR29_RLOCK_MASK 0x88
                  #define CR29_RUNLOCK    0x80
                  #define CR29_RLOCK      0x08

          #define CRT_EGA_EMU_SW 0x2A
          #define CRT_SCRATCH1 0x2B
          #define CRT_INTERL_START 0x2C
          #define CRT_INTERL_END 0x2D
          #define CRT_MISCC1 0x2E
          #define CRT_MISCC2 0x2F
                  #define CR2F_DACLOCK 0x01
                  #define CR2F_VGA256K 0x02
                  #define CR2F_PAGE_OE 0x04
                  #define CR2F_CRTCOFF_MASK 0x18
                  #define CR2F_CRTCOFF_B16 0x08
                  #define CR2F_CRTCOFF_B17 0x10
                  #define CR2F_CRTCMAX_MASK 0x60
                  #define CR2F_CRTCMAX_256 0x00
                  #define CR2F_CRTCMAX_128 0x40
                  #define CR2F_CRTCMAX_64  0x60
                  #define CR2F_LOCKSLEEP   0x80

          #define CRT_MISCC3 0x30
                  #define CR30_NOROM_C600 0x01

#endif /* #ifdef _wd90c00_h */












