#ifndef _EVHEAD_H_
#define _EVHEAD_H_

#define EVHEAD_MAX_VT	255
#define EVHEAD_NULL_VT	256

#define EVHEAD_STACK_IN	0
#define EVHEAD_STACK_OUT	1

#define EVHEAD_INSERT_HEAD 0
#define EVHEAD_INSERT_TAIL -1

#define EVHEAD_DUMP_NAMES  0x0001

typedef union evhead_info {
	struct {
		int vt;
		int stack;
		int dump;
	} debug;
	struct {
		int vt;
		int stack;
	} sendto;
	struct {
		int vt;
		int stack;
		ev_id class;
		int atindex;
	} insert;
	struct {
		int vt;
	} setfocus;
} evhead_info;

enum { CmdHeadDebug=0x8000,
       CmdHeadSendTo,		/* Stack to send rest of events to */
       CmdHeadInsert,		/* Attach a stack */
       CmdHeadSetFocus};	/* VT to set the focus to */

extern void init_head(void);

#endif /* _EVHEAD_H_ */
