/* 
 *	(c) 1997 Andreas Beck becka@sunserver1.rz.uni-duesseldorf.de
 * ------------------------------------------------------------------------
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU Library General Public License as 
 *	published by the Free Software Foundation; either version 2, or 
 *	(at your option) any later version.
 * 
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU Library General Public License for more details.
 *
 *	You should have received a copy of the GNU Library General Public 
 *	License	along with this program; see the file COPYING.LGPL .  
 *	If not, write to the Free Software Foundation, 675 Mass Ave, 
 *	Cambridge, MA 02139, USA.
 *
 * ------------------------------------------------------------------------
 */ 

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>

struct Xhooks { 
	Display *display;
	Colormap cmap;
	int cmap_first,cmap_last;
	Window window;
	GC  gc;
	GC  tempgc;          /* Used in putpixel */
	int screen;
	int XLibLock;        /* SpinLock would probably be more secure, but ... */
	int        nocols;   /* Number of colors in the colormap */
	ggi_color *colormap;
	int viswidth, visheight;
	int  relptr;
	sint16 oldmousex;
	sint16 oldmousey;
	uint8 relptr_keymask;
};

#define XLIB_PRIV(vis) ((struct Xhooks *)VIS_PRIVATE(vis))

#define RELPTR_KEYS { XK_Control_L, XK_Alt_L, 'm' }
#define RELPTR_KEYINUSE (1 | (1<<1) | (1<<2))
#define RELPTR_NUMKEYS  3

#define XLIB_DOSYNC(vis) \
{\
	if (!(VIS_FLAGS(vis) & GGIFLAG_ASYNC))\
		GGIflush(vis);\
}
