/* ---------------------------------------------------------------------------
** LibGGI GLIDE target - Event handling
** ---------------------------------------------------------------------------
** Copyright (C) 1997, Jon Taylor <taylorj@ecs.csus.edu>
**
** This library is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
** ---------------------------------------------------------------------------
*/

#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <linutil.h>

#include "glidevisual.h"
#include "ggi-dl.h"
#include "../common/evqueue.inc"

/************************** GGI Functions ***************************/
/* Event Handling */
ggi_event_mask GGIeventpoll(ggi_visual_t vis, ggi_event_mask mask,
			    struct timeval *t)
{

#define BUFFER_SIZE (sizeof(ggi_event)*4)
	int err, n, x, y, b;
	char c;
	struct timeval *timeout, t_zero = {0, 0};
	static int lx = 0, ly = 0, lb = 0, lastkey = 0;
	ggi_event_mask evmask;
	ggi_event ggievent;

	DPRINT("GGIeventpoll(%p,0x%.8x", vis, mask);
	if (t == NULL) 
	{
		
		DPRINT(",NULL)");
	} else 
	{
		
		DPRINT(",{%d,%d})", t->tv_sec, t->tv_usec);
	}

	evmask = _ggiEvQueueSeen(vis, mask);
	if (evmask != 0)
	{
	
		return evmask;
	}

	do 
	{
		
		ggievent.any.focus = 0;
		ggievent.any.device = 0;
		ggievent.any.time = 0;	/* FIXME! */
		ggievent.any.type = 0;
		
		if (!lin_kbhit && t &&
		    (t->tv_sec < 0 || (t->tv_sec == 0 && t->tv_usec == 0)))
		    break;
		
		while (!lin_kbhit());
		c = lin_getch();
		DPRINT("got event %d", c);
		ggievent.any.type = evKeyPress;
		ggievent.any.size = sizeof(ggi_key_event);
		ggievent.key.sym = c;
		ggievent.key.code = c;

		if (ggievent.any.type)
		{
			
			_ggiEvQueueAdd(vis, &ggievent);
		}
		
		evmask = _ggiEvQueueSeen(vis, mask);
DPRINT("Scooby 1 ");
	} while (evmask == 0);
DPRINT("Scooby 2 ");
	return evmask;
}

int GGIeventread(ggi_visual_t vis, ggi_event *ev, ggi_event_mask mask)
{
	/* Block if we don't have anything queued... */
	GGIeventpoll(vis, mask, NULL);
	return _ggiEvQueueRelease(vis, ev, mask);
}
