/* 
   Graphics library for GGI.

   Copyright (C) 1998 Marcus Sundberg - marcus@ggi-project.org

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "ggi-dl.h"
#include "vgaglvis.h"

int GGIdlinit(ggi_visual *visual,const char *args)
{
	if (args==NULL
		|| strncmp(args,"sVgALIb",7) != 0)
		return GGI_DL_ERROR;
	
	gl_setcontextvga(vga_getcurrentmode());

	/* Generic drawing
	 */
	visual->op2d->drawpixel=GGIdrawpixel;
	visual->op2d->putpixel=GGIputpixel;
	visual->op2d->getpixel=GGIgetpixel;
	visual->op2d->_drawpixel=_GGIdrawpixel;

	visual->op2d->drawhline=GGIdrawhline;
	visual->op2d->_drawhline=_GGIdrawhline;
	visual->op2d->gethline=GGIgethline;
	visual->op2d->puthline=GGIputhline;

	visual->op2d->drawvline=GGIdrawvline;
	visual->op2d->_drawvline=_GGIdrawvline;
	visual->op2d->getvline=GGIgetvline;
	visual->op2d->putvline=GGIputvline;
	
	visual->op2d->fillscreen=GGIfillscreen;

	visual->op2d->drawbox=GGIdrawbox;
	visual->op2d->putbox=GGIputbox;
	visual->op2d->getbox=GGIgetbox;

	/*visual->op2d->putc=GGIputc;
	visual->op2d->puts=GGIputs;

	visual->op2d->drawline=GGIdrawline;
	visual->op2d->crossblit=GGIcrossblit;*/

	return GGI_DL_OP2D;
}

int GGIdlcleanup(ggi_visual *visual)
{
	return EOK;
}

#include "ggidlinit.h"
