/*
 *	Copyright (C) 1998 Uwe Maurer - uwe_maurer@t-online.de
 */
#include <ggi/libggu.h>
#include <stdlib.h>
#include <stdio.h>

ggi_visual_t vis;

int main(int argc,char *argv[])
{
	int w,h;
	ggi_visual_t vismem;
	ggi_color pal[256];
	char *file="pal.gif";
	ggi_graphtype gt;

	gguInit();

	vis=gguCmdLineVisual(&argc,&argv,"--ggimode 640x480x8");
	vismem=ggiOpen("display-memory",NULL);

	if (vis==NULL ||vismem==NULL)
	{
		ggiPanic("Can't open visuals!\n");
	}

	if (argc>1) file=argv[1];
	gguImageInfo(file,&w,&h,&gt);
	printf("%s %ix%ix%i\n",file,w,h,gguBPP(gt));

	if (GGU_WIDTH(vis)>=w && GGU_HEIGHT(vis)>=h && GGU_GT(vis)==gt)
	{
		gguAdjustVisual(vis,GGU_FALSE);
		if (gguLoadImage(vis,file,pal))
		{
			ggiPanic("Can't open %s\n",file);
		}
		ggiSetPaletteVec(vis,0,256,pal);
	}
	else
	{
		if (gguLoadImage(vismem,file,pal))
		{
			ggiPanic("Can't open %s\n",file);
		}
		ggiCrossBlit(vismem,0,0,w,h,
			vis,0,0,GGU_WIDTH(vis),GGU_HEIGHT(vis));
	}

//	gguScreenShot(vis);

	ggiGetc(vis);
	ggiClose(vis);
	ggiClose(vismem);
	gguExit();
	exit(0);
}
