/* 
 *  GGI Utility library
 *
 *  Copyright (C) 1998 Uwe Maurer - uwe_maurer@t-online.de
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _LIBGGU_H_
#define _LIBGGU_H_

#include <ggi/libggi.h>
#include <ggi/libggi_db.h>
#include <unistd.h>

#define GGU_WIDTH(vis) 		(ggiGetInfo(vis)->mode->visible.x)
#define GGU_HEIGHT(vis) 	(ggiGetInfo(vis)->mode->visible.y)
#define GGU_VISIBLE(vis) 	(ggiGetInfo(vis)->mode->visible)
#define GGU_VIRT(vis) 		(ggiGetInfo(vis)->mode->virt)
#define GGU_GT(vis) 		(ggiGetInfo(vis)->mode->graphtype)
#define GGU_GRAPHTYPE(vis) 	GGU_GT(vis)
#define GGU_MODE(vis) 		(ggiGetInfo(vis)->mode)

/* init.c */
int	gguInit(void);
int	gguExit(void);

/* file.c */
int	gguScreenShot(ggi_visual_t vis);   
int	gguLoadImage(ggi_visual_t vis,char *file,ggi_color *pal);
int	gguSaveImage(ggi_visual_t vis,char *file,int x,int y,int w,int h,
			ggi_color *pal);
int 	gguImageInfo(char *file,int *w,int *h,ggi_graphtype *gt);

#define GGU_TRUE	1
#define GGU_FALSE	0
int 	gguAdjustVisual(ggi_visual_t vis,int adjust);

/* misc.c */
ggi_visual_t 	gguCmdLineVisual(int *argc,char **argv[],char *def);
ggi_graphtype 	gguGraphtype(int bpp);
int 		gguBPP(ggi_graphtype gt);
ggi_color 	gguColor(float r,float g,float b);	

ggi_pixellinearbuffer * gguGetPLB(ggi_visual_t vis);

#define GGU_MODELEN	128	
int 	gguModeToString(ggi_mode *mode,char *str);
int 	gguStringToMode(char *str,ggi_mode *mode);

/* palette.c */
extern ggi_color gguWhite;
extern ggi_color gguLightGray;
extern ggi_color gguGray;
extern ggi_color gguDarkGray;
extern ggi_color gguBlack;
extern ggi_color gguRed;
extern ggi_color gguPink;
extern ggi_color gguOrange;
extern ggi_color gguYellow;
extern ggi_color gguGreen;
extern ggi_color gguMagenta;
extern ggi_color gguCyan;
extern ggi_color gguBlue;


int 	gguPalFadeOut(ggi_visual_t vis); 
int 	gguPalFadeTo(ggi_visual_t vis,ggi_color *dest);
int 	gguPalMove(ggi_visual_t vis,int step);
int 	gguPalBlend(ggi_color *col,ggi_color src,ggi_color dest,
			int start,int len);

int 	gguPalRange(ggi_visual_t vis,int start,int len);
int 	gguPalFadeSteps(ggi_visual_t vis,int steps);

#endif
